/*globals define, QUnit, window*/
define([
    'jquery',
    'testsuite/qunit',
    'de_epages/presentation/inc/callbacktimeout',

    '$ready!'
], function ($, Q, callbacktimeout) {
    'use strict';

    QUnit.module("de_epages/presentation/inc/callbacktimeout", {
        setup: function () {
        },
        teardown: function () {
        }
    });

    Q.test('Check callback functionality', function () {
        var result = false;

        Q.strictEqual(
            false,
            result,
            'Initial value of return value'
        );

        callbacktimeout(function() {
            result = true;
        })();

        Q.strictEqual(
            true,
            result,
            'Value of callback'
        );

    });


    Q.asyncTest('Check fallback timeout functionality', function () {
        var result = false;

        Q.strictEqual(
            false,
            result,
            'Initial value of return value'
        );

        callbacktimeout(function() {
            result = true;
        });

        Q.strictEqual(
            false,
            result,
            'Value before fallback timeout'
        );

        setTimeout(function() {
            Q.strictEqual(
                true,
                result,
                'Value after fallback timeout'
            );

            Q.start();
        }, 2500);


    });

});
